/* $Header: heap.h,v 1.11 90/05/07 17:30:57 hmgr Exp $*/

#ifndef __HEAP_H_
#define __HEAP_H_

#include <stddef.h>

#define __HEAP_BLOCK_SIZE (4096)

struct _heap_block
{
	unsigned long size;
	_heap_block *link;
};

#define __HEAP_CHUNK_SIZE (sizeof(_heap_block))

class Heap
{
	int chunk_size;
	int block_size;
	_heap_block *free_list;
	unsigned long lstsize;
public:
	Heap(int cs = __HEAP_CHUNK_SIZE, int bs = __HEAP_BLOCK_SIZE);
	~Heap();
	void *alloc(unsigned long);
	void *realloc(void *, unsigned long, unsigned long);
	void free(void *, unsigned long);
	unsigned long lastsize() { return lstsize; }
	void *operator new(size_t);
	void operator delete(void *);
};

#endif /* __HEAP_H_ */
