/* $Header: sma.h,v 1.10 91/06/26 17:03:58 hmgr Exp $*/

#ifndef __SMA_H_
#define __SMA_H_

#include <stddef.h>

/* Shared memory allocator*/

class Sma
{
	char *_base;
	size_t *_head;
public:
	Sma(void *base, size_t static_size = 0, size_t size = 0);
	size_t alloc(size_t size);
	void free(size_t offset);
};

const size_t SMA_ALIGNMENT = 8;	/* aligned for 2*size_t or double*/

inline size_t
sma_align(size_t offset)
{
    return SMA_ALIGNMENT - (offset & (SMA_ALIGNMENT-1));
}


#endif /* __SMA_H_ */
